# Class HealthQuantity

java.lang.Object
com.codename1.health.HealthQuantity

public final class HealthQuantity extends Object

An immutable value paired with the `HealthUnit` it is expressed in.

There is deliberately no zero-argument `getValue()`. Reading a number out of a quantity forces the caller to name the unit they want it in, which removes an entire class of bug -- the pounds-read-as- kilograms mistake that silently scales every downstream chart by 2.2.

    HealthQuantity weight = sample.getQuantity();
    double kg = weight.getValue(HealthUnit.KILOGRAM);
    double lb = weight.getValue(HealthUnit.POUND);

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `HealthQuantity(double value, HealthUnit unit)`
  Creates a quantity.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `equals(Object o)`
  Two quantities are equal when they carry the same raw value and the same unit.
  `double`
  `getRawValue()`
  The value in `getUnit()`, without conversion.
  `HealthUnit`
  `getUnit()`
  The unit this quantity was created with.
  `double`
  `getValue(HealthUnit in)`
  The value converted into `in`.
  `int`
  `hashCode()`
  Returns a hash code value for the object.
  `HealthQuantity`
  `in(HealthUnit unit)`
  This quantity re-expressed in `unit`.
  `String`
  `toString()`
  Returns a string representation of the object.

  ### Methods inherited from class Object

  `clone, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### HealthQuantity

    public HealthQuantity(double value, HealthUnit unit)

    Creates a quantity.

    ###### Throws

    - `IllegalArgumentException`: if `unit` is null.

- ## Method Details

  - ### getUnit

    public HealthUnit getUnit()
    The unit this quantity was created with.

  - ### getValue

    public double getValue(HealthUnit in)

    The value converted into `in`.

    ###### Throws

    - `IllegalArgumentException`: if `in` measures a different dimension.

  - ### getRawValue

    public double getRawValue()
    The value in `getUnit()`, without conversion. Named so that it cannot be reached for by accident when `getValue(HealthUnit)` is what the caller actually wants.

  - ### in

    public HealthQuantity in(HealthUnit unit)
    This quantity re-expressed in `unit`. Returns `this` when the unit already matches.

  - ### equals

    public boolean equals(Object o)
    Two quantities are equal when they carry the same raw value and the same unit. Deliberately not conversion-aware: 1000 g and 1 kg are not `equals`, because making them so would give a class with floating-point-dependent equality and a hash code that cannot be consistent with it.
    Overrides:
      `equals` in class `Object`

  - ### hashCode

    public int hashCode()
    Description copied from class: `Object`
    Returns a hash code value for the object. This method is supported for the benefit of hashtables such as those provided by java.util.Hashtable. The general contract of hashCode is: Whenever it is invoked on the same object more than once during an execution of a Java application, the hashCode method must consistently return the same integer, provided no information used in equals comparisons on the object is modified. This integer need not remain consistent from one execution of an application to another execution of the same application. If two objects are equal according to the equals(Object) method, then calling the hashCode method on each of the two objects must produce the same integer result. It is not required that if two objects are unequal according to the equals(java.lang.Object) method, then calling the hashCode method on each of the two objects must produce distinct integer results. However, the programmer should be aware that producing distinct integer results for unequal objects may improve the performance of hashtables. As much as is reasonably practical, the hashCode method defined by class Object does return distinct integers for distinct objects. (This is typically implemented by converting the internal address of the object into an integer, but this implementation technique is not required by the JavaTM programming language.)
    Overrides:
      `hashCode` in class `Object`

  - ### toString

    public String toString()
    Description copied from class: `Object`
    Returns a string representation of the object. In general, the toString method returns a string that "textually represents" this object. The result should be a concise but informative representation that is easy for a person to read. It is recommended that all subclasses override this method. The toString method for class Object returns a string consisting of the name of the class of which the object is an instance, the at-sign character `@', and the unsigned hexadecimal representation of the hash code of the object. In other words, this method returns a string equal to the value of: getClass().getName() + '@' + Integer.toHexString(hashCode())
    Overrides:
      `toString` in class `Object`